package cn.iocoder.yudao.module.member.service.configtype;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.member.controller.admin.configtype.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.configtype.ConfigTypeDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.member.dal.mysql.configtype.ConfigTypeMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.member.enums.ErrorCodeConstants.*;

/**
 * 配置类型 Service 实现类
 *
 * @author 秦俊旗
 */
@Service
@Validated
public class ConfigTypeServiceImpl implements ConfigTypeService {

    @Resource
    private ConfigTypeMapper configTypeMapper;

    @Override
    public Long createConfigType(ConfigTypeSaveReqVO createReqVO) {
        // 插入
        ConfigTypeDO configType = BeanUtils.toBean(createReqVO, ConfigTypeDO.class);
        configTypeMapper.insert(configType);
        // 返回
        return configType.getId();
    }

    @Override
    public void updateConfigType(ConfigTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigTypeExists(updateReqVO.getId());
        // 更新
        ConfigTypeDO updateObj = BeanUtils.toBean(updateReqVO, ConfigTypeDO.class);
        configTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigType(Long id) {
        // 校验存在
        validateConfigTypeExists(id);
        // 删除
        configTypeMapper.deleteById(id);
    }

    private void validateConfigTypeExists(Long id) {
        if (configTypeMapper.selectById(id) == null) {
            throw exception(CONFIG_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public ConfigTypeDO getConfigType(Long id) {
        return configTypeMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigTypeDO> getConfigTypePage(ConfigTypePageReqVO pageReqVO) {
        return configTypeMapper.selectPage(pageReqVO);
    }

}